LOWDOWN_TERM_NEW(3)

NAME
lowdown_term_new - allocate a Markdown terminal renderer

LIBRARY
liblowdown

SYNOPSIS
#include <sys/queue.h>
#include <stdio.h>
#include <lowdown.h>
void *
lowdown_term_new(const struct lowdown_opts *opts);

DESCRIPTION
Allocates a terminal renderer using opts->cols, opts->hmargin, opts->vmargin, and opts->oflags, or 80 and all others zero, respectively, if opts is NULL. These fields are documented in lowdown(3). The returned pointer may be used with multiple invocations of lowdown_term_rndr(3) and must be freed with lowdown_term_free(3).

The bits recognised in opts->oflags are LOWDOWN_TERM_SHORTLINK, LOWDOWN_TERM_NOCOLOUR, and LOWDOWN_TERM_NOLINK.

RETURN VALUES
Returns a pointer to the renderer or NULL on memory failure. The returned pointer must be freed with lowdown_term_free(3).

EXAMPLES
The following parses b of length bsz and outputs in ANSI terminal format.

    struct lowdown_buf *out;
    struct lowdown_doc *doc;
    struct lowdown_node *n;
    void *rndr;
    if (setlocale(LC_CTYPE, "en_US.UTF-8") == NULL)
    	err(1, NULL);
    if ((doc = lowdown_doc_new(NULL)) == NULL)
    	err(1, NULL);
    if ((n = lowdown_doc_parse(doc, NULL, b, bsz, NULL)) == NULL)
    	err(1, NULL);
    if ((out = lowdown_buf_new(256)) == NULL)
    	err(1, NULL);
    if ((rndr = lowdown_term_new(NULL)) == NULL)
    	err(1, NULL);
    if (!lowdown_term_rndr(out, rndr, n))
    	err(1, NULL);
    fwrite(out->data, 1, out->size, stdout);
    lowdown_term_free(rndr);
    lowdown_buf_free(out);
    lowdown_node_free(n);
    lowdown_doc_free(doc);

SEE ALSO
lowdown(3), lowdown_term_free(3), lowdown_term_rndr(3)

STANDARDS
ANSI escape codes are described in ISO/IEC 6429, previously ECMA-48.